
!Object methodsFor: '*MathsOntologie' stamp: 'AlainBusser 10/26/2012 18:06'!
commeTexte
	"affichage"

	^self asString.! !

!Number methodsFor: '*MathsOntologie-printing' stamp: 'AlainBusser 10/27/2012 14:45'!
affiche

	^self printString.! !

!Number methodsFor: '*MathsOntologie-printing' stamp: 'AlainBusser 10/27/2012 14:45'!
afficheEnBase: UneBase

	^self printStringBase: UneBase.! !

!Number methodsFor: '*MathsOntologie-truncation and roundoff' stamp: 'AlainBusser 10/27/2012 14:50'!
arrondiA: UnNombre
	"rpond l'arrondi  UnNombre prs.
	Par exemple 2 racine arrondiA: 0.01 rpond 1.41"

	^self roundTo: UnNombre.! !

!Number methodsFor: '*MathsOntologie-truncation and roundoff' stamp: 'AlainBusser 10/27/2012 14:50'!
arrondiDfautA: UnNombre

	"rpond l'arrondi par dfaut;
	par exemple, 2 racine arrondiExcsA: 0.01 rpond 1.41"
	
	^self roundDownTo: UnNombre.! !

!Number methodsFor: '*MathsOntologie-truncation and roundoff' stamp: 'AlainBusser 10/27/2012 14:50'!
arrondiEntier

	"rpond l'arrondi  l'entier le plus proche;
	par exemple, 2 racine arrondiEntier rpond 1"
	
	^self rounded.! !

!Number methodsFor: '*MathsOntologie-truncation and roundoff' stamp: 'AlainBusser 10/27/2012 14:50'!
arrondiExcsA: UnNombre

	"rpond l'arrondi  l'excs;
	par exemple, 2 racine arrondiExcsA: 0.01 rpond 1.42"
	
	^self roundUpTo: UnNombre.! !

!Number methodsFor: '*MathsOntologie' stamp: 'AlainBusser 10/18/2012 11:44'!
auCarr

	^self squared.! !

!Number methodsFor: '*MathsOntologie' stamp: 'AlainBusser 11/2/2012 17:10'!
auCube

	^self puissance: 3.! !

!Number methodsFor: '*MathsOntologie' stamp: 'AlainBusser 10/25/2012 18:40'!
augmentDePourcents: unPourcentage
	"augmente d'un pourcentage.
	Par exemple 200 augmentDePourcents: 6 rpond 212"

	^self * (1 + (unPourcentage / 100)).! !

!Number methodsFor: '*MathsOntologie' stamp: 'AlainBusser 10/18/2012 12:13'!
avecLeSigneDe: UnNombre

	^UnNombre copySignTo: self.! !

!Number methodsFor: '*MathsOntologie-converting' stamp: 'AlainBusser 10/27/2012 14:54'!
commeDure

	^self asDuration.! !

!Number methodsFor: '*MathsOntologie-converting' stamp: 'AlainBusser 10/27/2012 14:54'!
commeDcimal

	^self asFloat.! !

!Number methodsFor: '*MathsOntologie-converting' stamp: 'AlainBusser 10/27/2012 14:54'!
commeDcimalGradu

	^self asScaledDecimal.! !

!Number methodsFor: '*MathsOntologie-converting' stamp: 'AlainBusser 10/27/2012 14:55'!
commeDcimalGradu: echelle

	^self asScaledDecimal: echelle.! !

!Number methodsFor: '*MathsOntologie-converting' stamp: 'AlainBusser 10/27/2012 14:55'!
commeEntier

	^self asInteger.! !

!Number methodsFor: '*MathsOntologie-converting' stamp: 'AlainBusser 10/27/2012 14:55'!
commeNombre

	^self asNumber.! !

!Number methodsFor: '*MathsOntologie' stamp: 'AlainBusser 10/20/2012 11:25'!
cosinus
	"cosinus en degrs"
	
	^self degreeCos.! !

!Number methodsFor: '*MathsOntologie' stamp: 'AlainBusser 10/18/2012 11:50'!
degrs

	^self radiansToDegrees.! !

!Number methodsFor: '*MathsOntologie-printing' stamp: 'AlainBusser 10/28/2012 17:32'!
enPourcents

	^(self *100) asString,' %'.! !

!Number methodsFor: '*MathsOntologie-testing' stamp: 'AlainBusser 10/27/2012 14:55'!
estDivisiblePar: UnNombre

	^self isDivisibleBy: UnNombre.! !

!Number methodsFor: '*MathsOntologie-testing' stamp: 'AlainBusser 10/27/2012 14:55'!
estInfini

	^self isInfinite.! !

!Number methodsFor: '*MathsOntologie-testing' stamp: 'AlainBusser 10/27/2012 14:55'!
estNul

	^self isZero.! !

!Number methodsFor: '*MathsOntologie-testing' stamp: 'AlainBusser 10/27/2012 14:54'!
estUnNombre

	^self isNumber.! !

!Number methodsFor: '*MathsOntologie-converting' stamp: 'AlainBusser 10/27/2012 14:56'!
heures

	^self hours.! !

!Number methodsFor: '*MathsOntologie' stamp: 'AlainBusser 10/18/2012 12:00'!
impair
	
	^self odd.! !

!Number methodsFor: '*MathsOntologie' stamp: 'AlainBusser 10/18/2012 18:15'!
inverse

	^self reciprocal.! !

!Number methodsFor: '*MathsOntologie-converting' stamp: 'AlainBusser 10/27/2012 14:56'!
jours

	^self days.! !

!Number methodsFor: '*MathsOntologie' stamp: 'AlainBusser 10/18/2012 11:34'!
jusque: UnNombre

	^self to: UnNombre.! !

!Number methodsFor: '*MathsOntologie' stamp: 'AlainBusser 10/18/2012 11:29'!
jusque: UnNombre faire: UnBloc
	"boucle  condition de sortie"

	^self to: UnNombre do: UnBloc.! !

!Number methodsFor: '*MathsOntologie' stamp: 'AlainBusser 10/28/2012 17:33'!
jusque: UnNombre parPasDe: UnPas

	"rpond un intervalle"

	^self to: UnNombre by: UnPas.! !

!Number methodsFor: '*MathsOntologie' stamp: 'AlainBusser 10/28/2012 17:33'!
jusque: UnNombre parPasDe: UnPas faire: UnBloc

	^self to: UnNombre by: UnPas do: UnBloc.! !

!Number methodsFor: '*MathsOntologie-converting' stamp: 'AlainBusser 10/27/2012 14:56'!
millisecondes

	^self milliSeconds.! !

!Number methodsFor: '*MathsOntologie-testing' stamp: 'AlainBusser 10/27/2012 14:54'!
nEstPasUnNombre

	^self isNaN.! !

!Number methodsFor: '*MathsOntologie-converting' stamp: 'AlainBusser 10/27/2012 14:53'!
nanosecondes

	^self nanoSeconds.! !

!Number methodsFor: '*MathsOntologie' stamp: 'AlainBusser 10/18/2012 11:59'!
ngatif
	
	^self negative.! !

!Number methodsFor: '*MathsOntologie' stamp: 'AlainBusser 10/18/2012 12:01'!
oppos

	^self negated.! !

!Number methodsFor: '*MathsOntologie' stamp: 'AlainBusser 10/18/2012 12:00'!
pair
	
	^self even.! !

!Number methodsFor: '*MathsOntologie-truncation and roundoff' stamp: 'AlainBusser 10/27/2012 14:49'!
partieEntire

	^self integerPart.! !

!Number methodsFor: '*MathsOntologie-truncation and roundoff' stamp: 'AlainBusser 10/27/2012 14:48'!
partieFractionnaire

	^self fractionPart.! !

!Number methodsFor: '*MathsOntologie' stamp: 'AlainBusser 10/18/2012 11:59'!
positif
	
	^self positive.! !

!Number methodsFor: '*MathsOntologie' stamp: 'AlainBusser 10/25/2012 18:38'!
pourcentsDe: UnNombre
	"rpond un pourcentage.
	Par exemple 6 pourcentsDe: 200 rpond 12"

	^self * UnNombre / 100.! !

!Number methodsFor: '*MathsOntologie' stamp: 'AlainBusser 10/18/2012 12:13'!
procheDe: UnNombre

	^self closeTo: UnNombre.! !

!Number methodsFor: '*MathsOntologie' stamp: 'AlainBusser 10/18/2012 11:50'!
puissance: UnNombre

	^self raisedTo: UnNombre.! !

!Number methodsFor: '*MathsOntologie' stamp: 'AlainBusser 10/18/2012 11:44'!
racine

	^self sqrt.! !

!Number methodsFor: '*MathsOntologie' stamp: 'AlainBusser 10/18/2012 16:46'!
racineNime: unEntier

	^self nthRoot: unEntier.! !

!Number methodsFor: '*MathsOntologie-converting' stamp: 'AlainBusser 10/27/2012 14:52'!
radians
	
	^self degreesToRadians.! !

!Number methodsFor: '*MathsOntologie' stamp: 'AlainBusser 10/18/2012 11:47'!
reste: UnNombre

	^self rem: UnNombre.! !

!Number methodsFor: '*MathsOntologie-converting' stamp: 'AlainBusser 10/27/2012 14:53'!
secondes

	^self seconds.! !

!Number methodsFor: '*MathsOntologie-converting' stamp: 'AlainBusser 10/27/2012 14:52'!
semaines

	^self weeks.! !

!Number methodsFor: '*MathsOntologie' stamp: 'AlainBusser 10/18/2012 11:45'!
signe
	
	^self sign.! !

!Number methodsFor: '*MathsOntologie' stamp: 'AlainBusser 10/20/2012 11:25'!
sinus
	"sinus en degrs"
	
	^self degreeSin.! !

!Number methodsFor: '*MathsOntologie' stamp: 'AlainBusser 10/18/2012 11:42'!
strictementPositif

	^self strictlyPositive.! !

!Number methodsFor: '*MathsOntologie' stamp: 'AlainBusser 10/20/2012 11:27'!
tangente
	"tangente en degrs"
	
	^(self sinus / (self cosinus)).! !

!Number methodsFor: '*MathsOntologie-truncation and roundoff' stamp: 'AlainBusser 10/27/2012 14:48'!
troncatureEntire


	^self floor.! !

!Number methodsFor: '*MathsOntologie-truncation and roundoff' stamp: 'AlainBusser 10/27/2012 14:47'!
tronqu
	^self truncated.! !

!Number methodsFor: '*MathsOntologie-truncation and roundoff' stamp: 'AlainBusser 10/27/2012 14:47'!
tronquA: UnNombre

	"affiche le nombre tronqu  UnOmbre prs.
	Par exemple, 2 racine tronquA: 0.01 renvoie 1.41"
	
	^self truncatedTo: UnNombre.! !

!ThreadSafeTranscript methodsFor: '*MathsOntologie' stamp: 'AlainBusser 10/19/2012 10:53'!
affiche: unObjet

	^self crShow: unObjet.! !

!ThreadSafeTranscript methodsFor: '*MathsOntologie' stamp: 'AlainBusser 10/19/2012 10:53'!
efface

	^self clear.! !

!ThreadSafeTranscript methodsFor: '*MathsOntologie' stamp: 'AlainBusser 10/19/2012 10:47'!
espace

	^self space.! !

!ThreadSafeTranscript methodsFor: '*MathsOntologie' stamp: 'AlainBusser 10/19/2012 10:48'!
montre: unObjet

	^self show: unObjet.! !

!SortedCollection methodsFor: '*MathsOntologie' stamp: 'AlainBusser 10/28/2012 17:37'!
Q1
	"rpond le premier quartile."

	^ self at: self size + 1 // 4! !

!SortedCollection methodsFor: '*MathsOntologie' stamp: 'AlainBusser 10/28/2012 17:38'!
Q3
	"rpond le troisime quartile."

	^ self reverse at: self size + 1 // 4! !

!True methodsFor: '*MathsOntologie' stamp: 'AlainBusser 10/18/2012 11:17'!
afficheSur: unFlux

	^self printOn: unFlux.! !

!Duration methodsFor: '*MathsOntologie' stamp: 'AlainBusser 10/29/2012 22:02'!
arrondiA: uneDure
	
	^self roundTo: uneDure.! !

!Duration methodsFor: '*MathsOntologie' stamp: 'AlainBusser 10/29/2012 22:05'!
enHeures

	^self asHours.! !

!Duration methodsFor: '*MathsOntologie' stamp: 'AlainBusser 10/29/2012 22:06'!
enJours
	
	^self asDays.! !

!Duration methodsFor: '*MathsOntologie' stamp: 'AlainBusser 10/29/2012 22:05'!
enMinutes

	^self asMinutes.! !

!Duration methodsFor: '*MathsOntologie' stamp: 'AlainBusser 10/29/2012 22:04'!
enNanosecondes

	^self asNanoSeconds.! !

!Duration methodsFor: '*MathsOntologie' stamp: 'AlainBusser 10/29/2012 22:04'!
enSecondes

	^self asSeconds.! !

!Duration methodsFor: '*MathsOntologie' stamp: 'AlainBusser 10/29/2012 22:05'!
enmillisecondes

	^self asMilliSeconds.! !

!Duration methodsFor: '*MathsOntologie' stamp: 'AlainBusser 10/29/2012 22:02'!
tronquA: uneDure
	
	^self truncateTo: uneDure.! !

!SmallInteger methodsFor: '*MathsOntologie' stamp: 'AlainBusser 10/27/2012 14:38'!
troisChiffresDnominateur

	| units answer |

	self = 0 siVrai: [^''].
	units := #('un' 'deux' 'trois' 'quatr' 'cinqu' 'six' 'sept' 'huit' 'neuv' 'dix' 
		'onz' 'douz' 'treiz' 'quatorz' 'quinz' 'seiz' 'dix-sept' 
		'dix-huit' 'dix-neuv').
	self > 99 siVrai: [
		self > 199 siVrai: [
		answer := (units at: self // 100),' cents'.
		] siFaux: [
		answer := 'cent'
		].
		(self \\ 100) = 0 ifFalse: [
			answer := answer,' ',(self \\ 100) troisChiffresEnNom
		].
		^answer
	].
	self < 20 ifTrue: [
		^units at: self
	].
	self < 60 siVrai: [
		(self \\ 10) =0 siVrai: [
			answer := #('vingt' 'trent' 'quarant' 'cinquant') en: self // 10 -1.
			] siFaux: [
	answer := #('vingt' 'trente' 'quarante' 'cinquante')
			at: self // 10 - 1.
			].
	(self \\ 10) = 0 ifFalse: [
		(self  \\ 10) = 1 siVrai: [
			answer := answer,'-et-un'.
			] siFaux: [
		answer := answer,'-',(units at: self \\ 10)
		].
	].
	] siFaux: [
	answer := #('soixante' 'quatre-vingt') en: self // 20 - 2.
	(self \\ 20) = 0 siFaux: [
		(self  \\ 10) = 1 siVrai: [
			answer := answer,'-et-',(units en: self \\ 20).
			] siFaux: [
		answer := answer,'-',(units en: self \\ 20)].
	].
	].
	^answer! !

!SmallInteger methodsFor: '*MathsOntologie' stamp: 'AlainBusser 10/26/2012 21:07'!
troisChiffresEnNom

	| units answer |

	self = 0 siVrai: [^''].
	units := #('un' 'deux' 'trois' 'quatre' 'cinq' 'six' 'sept' 'huit' 'neuf' 'dix' 
		'onze' 'douze' 'treize' 'quatorze' 'quinze' 'seize' 'dix-sept' 
		'dix-huit' 'dix-neuf').
	self > 99 siVrai: [
		self > 199 siVrai: [
		answer := (units at: self // 100),' cents'.
		] siFaux: [
		answer := 'cent'
		].
		(self \\ 100) = 0 ifFalse: [
			answer := answer,' ',(self \\ 100) troisChiffresEnNom
		].
		^answer
	].
	self < 20 ifTrue: [
		^units at: self
	].
	self < 60 siVrai: [
	answer := #('vingt' 'trente' 'quarante' 'cinquante')
			at: self // 10 - 1.
	(self \\ 10) = 0 ifFalse: [
		(self  \\ 10) = 1 siVrai: [
			answer := answer,'-et-un'.
			] siFaux: [
		answer := answer,'-',(units at: self \\ 10)
		].
	].
	] siFaux: [
	answer := #('soixante' 'quatre-vingt') en: self // 20 - 2.
	(self \\ 20) = 0 siFaux: [
		(self  \\ 10) = 1 siVrai: [
			answer := answer,'-et-',(units en: self \\ 20).
			] siFaux: [
		answer := answer,'-',(units en: self \\ 20)].
	].
	].
	^answer! !

!Fraction methodsFor: '*MathsOntologie-printing' stamp: 'AlainBusser 10/27/2012 14:35'!
avecDesMots

	| t q |
	q := #('unime' 'demi' 'tiers' 'quart').
	t := self numrateur avecDesMots.
	(self dnominateur > 1) siVrai: [
		t := t,' '.
		(self dnominateur < 5) siVrai: [
			t := t,(q en: self dnominateur).
			]
		siFaux: [
			t := t,(self dnominateur avecDesMotsDn),'ime'.
			].
		(self numrateur > 1 et: (self dnominateur =3) contraire) siVrai: [
			t := t,'s'.
			]
		].
	^t.! !

!Fraction methodsFor: '*MathsOntologie-printing' stamp: 'AlainBusser 10/27/2012 14:34'!
commePari
	"rpond la fraction comme probabilit"

	| c |
	c := self numrateur asString.
	(self numrateur < 2) siVrai: [
		c := c,' chance contre '.
		] siFaux:[
		c := c,' chances contre '.
		].
	c := c,(self dnominateur - self numrateur) asString.
	^c! !

!Fraction methodsFor: '*MathsOntologie-printing' stamp: 'AlainBusser 10/27/2012 14:34'!
commeProba
	"rpond la fraction comme probabilit"

	| c |
	c := self numrateur asString.
	(self numrateur < 2) siVrai: [
		c := c,' chance sur '.
		] siFaux:[
		c := c,' chances sur '.
		].
	c := c,self dnominateur asString.
	^c! !

!Fraction methodsFor: '*MathsOntologie' stamp: 'AlainBusser 10/25/2012 18:45'!
de: unNombre

	^self * unNombre.! !

!Fraction methodsFor: '*MathsOntologie' stamp: 'AlainBusser 10/18/2012 17:02'!
dnominateur

	^self denominator.! !

!Fraction methodsFor: '*MathsOntologie' stamp: 'AlainBusser 10/18/2012 17:04'!
estUnePuissanceDe2

	^self isPowerOfTwo.! !

!Fraction methodsFor: '*MathsOntologie' stamp: 'AlainBusser 10/18/2012 17:02'!
numrateur

	^self numerator.! !

!Fraction methodsFor: '*MathsOntologie' stamp: 'AlainBusser 10/18/2012 17:01'!
rduite

	^self reduced.! !

!Fraction methodsFor: '*MathsOntologie-printing' stamp: 'AlainBusser 10/27/2012 14:33'!
Lancienne
	"rpond la fraction  l'ancienne, avec partie entire"

	| a b |
	a := self partieEntire.
	b := self partieFractionnaire.
	^(a asString),'+',(b asString).! !

!Fraction methodsFor: '*MathsOntologie-printing' stamp: 'AlainBusser 10/27/2012 14:33'!
Lgyptienne
	"rpond la fraction comme somme de fractions gyptiennes
	soit de numrateurs 1;
	algorithme de Fibonacci-Sylvester"

	| liste b c chaine |
	liste := #() commeCollectionOrdonne.
	liste ajoute: self partieEntire.
	b := self partieFractionnaire.
	[b numrateur > 1] tantQueVrai: [
		c := (b inverse partieEntire + 1) inverse.
		b := b-c.
		liste ajoute: c.
	].
	liste ajoute: b.
	chaine := (liste commeTableau en: 1) asString.
	liste := liste retireTousTelsQue: [ :n | n isInteger].
	liste := liste commeTableau.
	liste fais: [ :elt | chaine := chaine,' + ',(elt asString)].
	
	^chaine.! !

!Boolean methodsFor: '*MathsOntologie' stamp: 'AlainBusser 10/26/2012 18:04'!
contraire
	"ngation boolenne"
	
	^self not.! !

!Boolean methodsFor: '*MathsOntologie' stamp: 'AlainBusser 10/15/2012 21:39'!
et: UnBloc
	"et au lieu de and"

	^self and: UnBloc.! !

!Boolean methodsFor: '*MathsOntologie' stamp: 'AlainBusser 10/15/2012 21:40'!
ou: UnBloc
	"ou au lieu de or"

	^self or: UnBloc.! !

!Boolean methodsFor: '*MathsOntologie' stamp: 'AlainBusser 10/15/2012 21:48'!
siFaux: UnBloc
	"test ngatif"

	^self ifFalse: UnBloc.! !

!Boolean methodsFor: '*MathsOntologie' stamp: 'AlainBusser 10/28/2012 17:30'!
siFaux: leBlocDuFaux siVrai: leBlocDuVrai
	"test alternatif"

	^self ifFalse: leBlocDuFaux ifTrue: leBlocDuVrai.! !

!Boolean methodsFor: '*MathsOntologie' stamp: 'AlainBusser 10/15/2012 21:47'!
siVrai: UnBloc
	"test positif"

	^self ifTrue: UnBloc.! !

!Boolean methodsFor: '*MathsOntologie' stamp: 'AlainBusser 10/15/2012 21:51'!
siVrai: leBlocDuVrai siFaux: leBlocDuFaux
	"test alternatif"

	^self ifTrue: leBlocDuVrai ifFalse: leBlocDuFaux.! !

!BlockClosure methodsFor: '*MathsOntologie' stamp: 'AlainBusser 10/20/2012 16:33'!
tantQueFaux: unBloc

	^self whileFalse: unBloc.! !

!BlockClosure methodsFor: '*MathsOntologie' stamp: 'AlainBusser 10/20/2012 16:33'!
tantQueVrai: unBloc

	^self whileTrue: unBloc.! !

!BlockClosure methodsFor: '*MathsOntologie' stamp: 'AlainBusser 10/20/2012 16:25'!
valeur
	
	^self value.! !

!BlockClosure methodsFor: '*MathsOntologie' stamp: 'AlainBusser 10/20/2012 16:26'!
valeur: unArgument
	
	^self value: unArgument.! !

!False methodsFor: '*MathsOntologie' stamp: 'AlainBusser 10/15/2012 21:54'!
afficheSur: unFlux

	^self printOn: unFlux.! !

!Integer methodsFor: '*MathsOntologie' stamp: 'AlainBusser 11/2/2012 17:08'!
BezoutAvec: unEntier
	"rpond une solution (u,v) de Bezout"

	| g u v eq a b s |
	g := self pgcd: unEntier.
	eq := (self asString),' u + ',(unEntier asString),'  v = ',(g asString).
	a := self // g.
	b := unEntier // g.
	u := (a modulo: b) inverseModulo: b.
	v := (1 - a * u) // b.
	s := '(',(u asString),';',(v asString),') est solution de ',eq.
	^s.! !

!Integer methodsFor: '*MathsOntologie' stamp: 'AlainBusser 10/18/2012 17:15'!
auHasard

	^self atRandom.! !

!Integer methodsFor: '*MathsOntologie-printing' stamp: 'AlainBusser 10/26/2012 20:42'!
avecDesMots
	"SmallInteger maxVal asWords"
	| mils minus three num answer milCount |
	self = 0 ifTrue: [^'zero'].
	mils := #('' ' mille' ' millions' ' milliards' ' billions' ' billiards' ' trillions' ' trilliards' ' quadrillions' ' quadrilliards' ' quintillions' ' quintilliards' ' sextillions' ' sextilliards' ' septillions' ' septilliards' ' octillions' ' octilliards' ' nonillions' ' nonilliards' ' dcillions' ' dcilliards').
	num := self.
	minus := ''.
	self < 0 ifTrue: [
		minus := 'moins '.
		num := num negated.
	].
	answer := String new.
	milCount := 1.
	[num > 0] whileTrue: [
		three := (num \\ 1000) troisChiffresEnNom.
		num := num // 1000.
		three isEmpty ifFalse: [
			answer isEmpty ifFalse: [
				answer := ' ',answer
			].
			answer := three,(mils at: milCount),answer.
		].
		milCount := milCount + 1.
	].
	^minus,answer! !

!Integer methodsFor: '*MathsOntologie-printing' stamp: 'AlainBusser 10/27/2012 14:32'!
avecDesMotsDn
	"SmallInteger maxVal asWords"
	| mils minus three num answer milCount |
	self = 0 ifTrue: [^'zero'].
	mils := #('' ' mille' ' millions' ' milliards' ' billions' ' billiards' ' trillions' ' trilliards' ' quadrillions' ' quadrilliards' ' quintillions' ' quintilliards' ' sextillions' ' sextilliards' ' septillions' ' septilliards' ' octillions' ' octilliards' ' nonillions' ' nonilliards' ' dcillions' ' dcilliards').
	num := self.
	minus := ''.
	self < 0 ifTrue: [
		minus := 'moins '.
		num := num negated.
	].
	answer := String new.
	milCount := 1.
	[num > 0] whileTrue: [
		three := (num \\ 1000) troisChiffresDnominateur.
		num := num // 1000.
		three isEmpty ifFalse: [
			answer isEmpty ifFalse: [
				answer := ' ',answer
			].
			answer := three,(mils at: milCount),answer.
		].
		milCount := milCount + 1.
	].
	^minus,answer! !

!Integer methodsFor: '*MathsOntologie-printing' stamp: 'AlainBusser 10/26/2012 20:41'!
commeFraction

	^self asFraction.! !

!Integer methodsFor: '*MathsOntologie' stamp: 'AlainBusser 10/26/2012 18:28'!
diviseurs
	"rpond les diviseurs du nombre placs dans un tableau" 

	^(1 jusque: self) choisis: [ :d | self \\ d = 0].! !

!Integer methodsFor: '*MathsOntologie-printing' stamp: 'AlainBusser 10/26/2012 20:41'!
enChiffresRomains

	^self printStringRoman.! !

!Integer methodsFor: '*MathsOntologie' stamp: 'AlainBusser 10/30/2012 22:27'!
estDivisiblePar: unEntier

	^(self \\ unEntier) =0.! !

!Integer methodsFor: '*MathsOntologie' stamp: 'AlainBusser 10/18/2012 17:16'!
estPremier

	^self isPrime.! !

!Integer methodsFor: '*MathsOntologie' stamp: 'AlainBusser 10/30/2012 22:27'!
estPremierAvec: unEntier

	^(self pgcd: unEntier) = 1.! !

!Integer methodsFor: '*MathsOntologie' stamp: 'AlainBusser 10/18/2012 17:16'!
estProbablementPremier

	^self isProbablyPrime.! !

!Integer methodsFor: '*MathsOntologie' stamp: 'AlainBusser 10/18/2012 17:30'!
extrait: unEntier

	^self take: unEntier.! !

!Integer methodsFor: '*MathsOntologie' stamp: 'AlainBusser 10/24/2012 19:03'!
facteursPremiers
	"met les facteurs premiers dans un sac"

	| sac n diviseur |
	sac := #() commeSac.
	n := self.
	diviseur := 2.
	[ diviseur <= n] tantQueVrai: [
		[n \\ diviseur =0] tantQueVrai: [
			sac ajoute: diviseur.
			n := n // diviseur.
		].
		(diviseur=2) siVrai: [
			diviseur := 3.
			] siFaux: [
			diviseur := diviseur+2.
			]
	].
	^sac tri.! !

!Integer methodsFor: '*MathsOntologie' stamp: 'AlainBusser 10/18/2012 17:25'!
factorielle

	^self factorial.! !

!Integer methodsFor: '*MathsOntologie' stamp: 'AlainBusser 10/18/2012 17:07'!
foisRpte: unBloc

	^self timesRepeat: unBloc.! !

!Integer methodsFor: '*MathsOntologie' stamp: 'AlainBusser 10/18/2012 17:11'!
inverseModulo: unEntier

	^self reciprocalModulo: unEntier.! !

!Integer methodsFor: '*MathsOntologie' stamp: 'AlainBusser 10/24/2012 15:26'!
modulo: unEntier

	^self \\ unEntier.! !

!Integer methodsFor: '*MathsOntologie' stamp: 'AlainBusser 10/18/2012 17:23'!
nombreDeChiffres

	^self numberOfDigits.! !

!Integer methodsFor: '*MathsOntologie' stamp: 'AlainBusser 10/18/2012 17:23'!
nombreDeChiffresEnBase: uneBase

	^self numberOfDigitsInBase: uneBase.! !

!Integer methodsFor: '*MathsOntologie' stamp: 'AlainBusser 10/18/2012 17:24'!
pgcd: unEntier

	^self gcd: unEntier.! !

!Integer methodsFor: '*MathsOntologie' stamp: 'AlainBusser 10/18/2012 17:24'!
ppcm: unEntier

	^self lcm: unEntier.! !

!Integer methodsFor: '*MathsOntologie' stamp: 'AlainBusser 10/27/2012 14:58'!
prcdent
	"dcrmente un entier"

	^self - 1.! !

!Integer methodsFor: '*MathsOntologie' stamp: 'AlainBusser 10/18/2012 17:13'!
puissance: exp modulo: unEntier

	^self raisedTo: exp modulo: unEntier.! !

!Integer methodsFor: '*MathsOntologie' stamp: 'AlainBusser 10/27/2012 14:58'!
suivant
	"incrmente un entier"

	^self + 1.! !

!Float methodsFor: '*MathsOntologie' stamp: 'AlainBusser 10/18/2012 16:56'!
commeFraction

	^self asFraction.! !

!Float methodsFor: '*MathsOntologie' stamp: 'AlainBusser 10/18/2012 16:57'!
commeFractionApproche

	^self asApproximateFraction.! !

!Float methodsFor: '*MathsOntologie' stamp: 'AlainBusser 10/18/2012 16:56'!
commeFractionApproche: ordre

	^self asApproximateFraction: ordre.! !

!Float methodsFor: '*MathsOntologie' stamp: 'AlainBusser 10/18/2012 16:57'!
commeFractionApprocheDordre: ordre

	^self asApproximateFractionAtOrder: ordre.! !

!Float methodsFor: '*MathsOntologie' stamp: 'AlainBusser 10/18/2012 16:55'!
commeFractionDcimale

	^self asMinimalDecimalFraction.! !

!Float methodsFor: '*MathsOntologie' stamp: 'AlainBusser 10/18/2012 16:54'!
commeVraieFraction

	^self asTrueFraction.! !

!Collection methodsFor: '*MathsOntologie-modification' stamp: 'AlainBusser 10/19/2012 11:42'!
ajoute: unObjet

	^self add: unObjet.! !

!Collection methodsFor: '*MathsOntologie-modification' stamp: 'AlainBusser 10/19/2012 11:43'!
ajoute: unObjet fois: unEntier

	^self add: unObjet withOccurences: unEntier.! !

!Collection methodsFor: '*MathsOntologie-modification' stamp: 'AlainBusser 10/19/2012 11:45'!
ajouteAuBesoin: unObjet

	^self addIfNotPresent: unObjet.! !

!Collection methodsFor: '*MathsOntologie-modification' stamp: 'AlainBusser 10/19/2012 11:44'!
ajouteTout: uneCollection

	^self addAll: uneCollection.! !

!Collection methodsFor: '*MathsOntologie-statistiques' stamp: 'AlainBusser 10/20/2012 11:36'!
arrondis

	^self rounded.! !

!Collection methodsFor: '*MathsOntologie-statistiques' stamp: 'AlainBusser 10/20/2012 11:34'!
auCarr

	^self squared.! !

!Collection methodsFor: '*MathsOntologie-statistiques' stamp: 'AlainBusser 10/19/2012 11:51'!
auHasard

	^self atRandom.! !

!Collection methodsFor: '*MathsOntologie-boucles' stamp: 'AlainBusser 10/20/2012 11:54'!
aucunNeVrifie: unBloc

	^self noneSatisfy: unBloc.! !

!Collection methodsFor: '*MathsOntologie-boucles' stamp: 'AlainBusser 10/24/2012 16:49'!
choisis: unBloc
	
	^self select: unBloc.! !

!Collection methodsFor: '*MathsOntologie-boucles' stamp: 'AlainBusser 10/26/2012 18:19'!
choisis: bloc ensuite: unBloc
	
	^self select: bloc thenDo: unBloc.! !

!Collection methodsFor: '*MathsOntologie-conversion' stamp: 'AlainBusser 10/19/2012 11:55'!
commeCollectionOrdonne

	^self asOrderedCollection.! !

!Collection methodsFor: '*MathsOntologie-conversion' stamp: 'AlainBusser 10/19/2012 11:55'!
commeCollectionTrie

	^self asSortedCollection.! !

!Collection methodsFor: '*MathsOntologie-conversion' stamp: 'AlainBusser 10/19/2012 11:56'!
commeDictionnaire

	^self asDictionary.! !

!Collection methodsFor: '*MathsOntologie-conversion' stamp: 'AlainBusser 10/19/2012 11:54'!
commeEnsemble

	^self asSet.! !

!Collection methodsFor: '*MathsOntologie-conversion' stamp: 'AlainBusser 10/19/2012 11:57'!
commeSac

	^self asBag.! !

!Collection methodsFor: '*MathsOntologie-conversion' stamp: 'AlainBusser 10/19/2012 11:57'!
commeTableau

	^self asArray.! !

!Collection methodsFor: '*MathsOntologie-boucles' stamp: 'AlainBusser 10/24/2012 16:50'!
compte: unBloc
	
	^self count: unBloc.! !

!Collection methodsFor: '*MathsOntologie-statistiques' stamp: 'AlainBusser 10/20/2012 11:39'!
cosinus
	
	^self degreeCos.! !

!Collection methodsFor: '*MathsOntologie-testing' stamp: 'AlainBusser 10/18/2012 18:01'!
estVide

	^self isEmpty.! !

!Collection methodsFor: '*MathsOntologie-boucles' stamp: 'AlainBusser 10/24/2012 16:50'!
exclus: unBloc
	
	^self reject: unBloc.! !

!Collection methodsFor: '*MathsOntologie-boucles' stamp: 'AlainBusser 10/24/2012 16:50'!
exclus: bloc ensuite: unBloc
	
	^self reject: bloc thenDo: unBloc.! !

!Collection methodsFor: '*MathsOntologie-boucles' stamp: 'AlainBusser 10/26/2012 18:19'!
fais: unBloc
	
	^self do: unBloc.! !

!Collection methodsFor: '*MathsOntologie-boucles' stamp: 'AlainBusser 10/20/2012 11:59'!
groupsPar: unBloc

	^self groupedBy: unBloc.! !

!Collection methodsFor: '*MathsOntologie-boucles' stamp: 'AlainBusser 10/20/2012 11:58'!
groupsPar: unBloc telsQue: condition

	^self groupedBy: unBloc having: condition.! !

!Collection methodsFor: '*MathsOntologie-boucles' stamp: 'AlainBusser 10/24/2012 16:51'!
injecte: valeur dans: unBloc

	^self inject: valeur into: unBloc.! !

!Collection methodsFor: '*MathsOntologie-boucles' stamp: 'AlainBusser 10/20/2012 11:41'!
inter: uneCollection
	
	^self intersection: uneCollection.! !

!Collection methodsFor: '*MathsOntologie-statistiques' stamp: 'AlainBusser 10/20/2012 11:35'!
inverses

	^self reciprocal.! !

!Collection methodsFor: '*MathsOntologie-statistiques' stamp: 'AlainBusser 10/20/2012 11:30'!
moyenne

	^self average.! !

!Collection methodsFor: '*MathsOntologie-statistiques' stamp: 'AlainBusser 10/19/2012 11:40'!
mdiane

	^self median.! !

!Collection methodsFor: '*MathsOntologie-statistiques' stamp: 'AlainBusser 10/20/2012 11:35'!
opposs

	^self negated.! !

!Collection methodsFor: '*MathsOntologie-boucles' stamp: 'AlainBusser 10/26/2012 18:19'!
picore: unBloc
	
	^self collect: unBloc.! !

!Collection methodsFor: '*MathsOntologie-boucles' stamp: 'AlainBusser 10/26/2012 18:18'!
picore: unBloc puisChoisis: critre
	
	^self collect: unBloc thenSelect: critre.! !

!Collection methodsFor: '*MathsOntologie-boucles' stamp: 'AlainBusser 10/26/2012 18:18'!
picore: unBloc puisFais: autreBloc
	
	^self collect: unBloc thenDo: autreBloc.! !

!Collection methodsFor: '*MathsOntologie-boucles' stamp: 'AlainBusser 10/26/2012 18:18'!
picore: unBloc vers: uneCollection
	
	^self collect: unBloc into: uneCollection.! !

!Collection methodsFor: '*MathsOntologie-statistiques' stamp: 'AlainBusser 10/28/2012 17:41'!
premierQuartile

	^self commeCollectionOrdonne Q1.! !

!Collection methodsFor: '*MathsOntologie-statistiques' stamp: 'AlainBusser 10/20/2012 11:31'!
puissance: unExposant

	^self raisedTo: unExposant.! !

!Collection methodsFor: '*MathsOntologie-statistiques' stamp: 'AlainBusser 10/20/2012 11:34'!
racines

	^self sqrt.! !

!Collection methodsFor: '*MathsOntologie-boucles' stamp: 'AlainBusser 10/24/2012 16:51'!
regroupe: unBloc
	
	^self gather: unBloc.! !

!Collection methodsFor: '*MathsOntologie-modification' stamp: 'AlainBusser 10/19/2012 11:08'!
retire: unBloc

	^self remove: unBloc.! !

!Collection methodsFor: '*MathsOntologie-modification' stamp: 'AlainBusser 10/19/2012 11:07'!
retireTousTelsQue: unBloc

	^self removeAllSuchThat: unBloc.! !

!Collection methodsFor: '*MathsOntologie-modification' stamp: 'AlainBusser 10/19/2012 11:22'!
retireTout

	^self removeAll.! !

!Collection methodsFor: '*MathsOntologie-modification' stamp: 'AlainBusser 10/19/2012 11:22'!
retireToutCeQuiEstDans: uneCollection

	^self removeAll: uneCollection.! !

!Collection methodsFor: '*MathsOntologie-boucles' stamp: 'AlainBusser 10/26/2012 18:17'!
rduis: unBloc

	^self reduce: unBloc.! !

!Collection methodsFor: '*MathsOntologie-statistiques' stamp: 'AlainBusser 10/20/2012 11:39'!
sinus
	
	^self degreeSin.! !

!Collection methodsFor: '*MathsOntologie-statistiques' stamp: 'AlainBusser 10/20/2012 11:32'!
somme

	^self sum.! !

!Collection methodsFor: '*MathsOntologie-statistiques' stamp: 'AlainBusser 10/19/2012 11:50'!
taille

	^self size.! !

!Collection methodsFor: '*MathsOntologie-statistiques' stamp: 'AlainBusser 10/20/2012 11:32'!
total

	^self sum.! !

!Collection methodsFor: '*MathsOntologie-boucles' stamp: 'AlainBusser 10/20/2012 12:19'!
tousVrifient: unBloc

	^self allSatisfy: unBloc.! !

!Collection methodsFor: '*MathsOntologie-modification' stamp: 'AlainBusser 10/19/2012 11:53'!
tri
	
	^self sorted.! !

!Collection methodsFor: '*MathsOntologie-boucles' stamp: 'AlainBusser 10/20/2012 11:45'!
triSelon: unBloc
	
	^self sorted: unBloc.! !

!Collection methodsFor: '*MathsOntologie-statistiques' stamp: 'AlainBusser 10/28/2012 17:42'!
troisimeQuartile

	^self commeCollectionOrdonne Q3.! !

!Collection methodsFor: '*MathsOntologie-boucles' stamp: 'AlainBusser 10/20/2012 12:19'!
unVrifie: unBloc

	^self anySatisfy: unBloc.! !

!Collection methodsFor: '*MathsOntologie-statistiques' stamp: 'AlainBusser 10/19/2012 11:40'!
cartType

	^self stdev.! !

!Collection methodsFor: '*MathsOntologie-statistiques' stamp: 'AlainBusser 10/20/2012 11:32'!
tendue

	^self range.! !

!Array methodsFor: '*MathsOntologie-modification' stamp: 'AlainBusser 10/20/2012 17:45'!
en: unIndice
	
	^self at: unIndice.! !

!Array methodsFor: '*MathsOntologie-modification' stamp: 'AlainBusser 10/26/2012 18:17'!
en: unIndice pose: unObjet
	
	^self at: unIndice put: unObjet.! !
